﻿
; Générateur de lancé de dès // Ar-S For APP JAM - 10 dec 2016

Declare Loadimages()
Declare RandomiZ()
Declare Launch(N)
Declare HowManyDices()
Declare Change()

Enumeration 10
  #WIN
  #CANV
  #IMG
  #REGE
  #BT_LAUNCH
  #BT_CHANGE
  #T
  #SON
  #F
EndEnumeration

Enumeration 1
  #D1
  #D2
  #D3
  #D4
  #D5
  #D6
EndEnumeration



UsePNGImageDecoder()


XIncludeFile("datas.pbi")


Global.b NbrDes, SoundOn, Launch

Global LargWin
Global TailleF = 32
Global Police = LoadFont(#F, "Verdana", TailleF, #PB_Font_HighQuality) 

If InitSound()
  SoundOn = #True
  UseOGGSoundDecoder()
  Global Son    = CatchSound(#SON, ?wav_start, ?wav_end - ?wav_start)
Else
  SoundOn = #False
EndIf

Global Image  = CatchImage(#img, ?des_start, ?des_end - ?des_start)


Procedure Loadimages()
  Xdes = 0
  StartDrawing(CanvasOutput(#CANV))
  For i = 1 To 6
    GrabImage(#IMG, i, Xdes, 0, 128, 128)
    Xdes + 128
  Next
  StopDrawing()
  FreeImage(#img)
EndProcedure


Procedure Launch(N)
  Protected x
  X = 0
  RandomSeed( RandomiZ() )
  
  start:
  Police = LoadFont(#F, "Verdana", TailleF, #PB_Font_HighQuality) 
  
  StartDrawing(CanvasOutput(#CANV))
  
  Box(0,0,LargWin,128,$111111)
  DrawingFont(Police)
  t.s = "EnJoY YoUr DiCeS"
  LT = TextWidth(t)
  HT = TextHeight(t)
  If LT > LargWin
    TailleF - 2
    StopDrawing()
    Goto start
    
  Else
    DrawText( (LargWin/2) - (LT/2), (128/2) - (HT/2), t, $FFFFFF, $111111)
    StopDrawing()
  EndIf
  
EndProcedure


Procedure Change()
  NbrDes = HowManyDices()
  TailleF = 32
  ; Pas bonne valeur ou 0 : Par défaut 6 dès
  Select NbrDes
      
    Case 0
      LargWin = 768
      NbrDes = 6
    Case 1
      LargWin = 128 * 2  
    Case 2 To 6
      LargWin = 128 * NbrDes
  EndSelect
  
  HideWindow(#win,1)
  
  ResizeWindow(#Win, #PB_Ignore, #PB_Ignore, LargWin, #PB_Ignore)
  ResizeGadget(#CANV,0,0,LargWin,128)
  ResizeGadget(#BT_LAUNCH,0,129,LargWin,25)
  ResizeGadget(#BT_CHANGE,0,155,LargWin,25)
  
  Launch(NbrDes)
  
  HideWindow(#win,0)
  
EndProcedure


Procedure RandomiZ()
  ProcedureReturn Val(Str(DayOfWeek(Date())) + Str(Month(Date())) + Str(Year(Date())) + Str(Hour(Date())) + Str(Minute(Date())) + Str(Second(Date())))
EndProcedure

Procedure HowManyDices()
  Protected OK.b
  
  Reponse$ = InputRequester("How Many Dices","How many dices do you want (1 to 6)","")
  If Reponse$ > ""
    If CreateRegularExpression(#REGE, "[1-6]{1}",#PB_RegularExpression_Extended)
      If MatchRegularExpression(#REGE, Reponse$) = 1
        OK = Val(Reponse$)
      Else
        OK = 5
        MessageRequester("Error","Wrong value, defaut number is 5",#MB_ICONERROR)
      EndIf
      
    EndIf
  Else
    MessageRequester("Erreur","Wrong value, defaut number is 5",#MB_ICONERROR)
    Debug "Vous devez entrer un chiffre"
    OK = 5
  EndIf
  
  ProcedureReturn OK
  
EndProcedure



NbrDes = HowManyDices()
; Pas bonne valeur ou 0 : Par défaut 6 dès
Select NbrDes
    

  Case 1
    LargWin = 128 * 2  
  Case 2 To 6
    LargWin = 128 * NbrDes
  Default 
    NbrDes = 5
    LargWin = 128 * NbrDes
EndSelect

OpenWindow(#WIN, #PB_Ignore, #PB_Ignore, LargWin, 128+50,"Virtual Dices",#PB_Window_ScreenCentered|#PB_Window_SystemMenu)
StickyWindow(#win,1)
CanvasGadget(#CANV,0,0,LargWin,128)
ButtonGadget(#BT_LAUNCH,0,129,LargWin,25,"LAUNCH")
ButtonGadget(#BT_CHANGE,0,155,LargWin,25,"CHANGE NUMBER OF DICES")
Loadimages()
launch(NbrDes)
RandomiZ()
AddWindowTimer(#WIN,#T,300)

Repeat
  Event = WindowEvent()
  Select Event 
    Case #PB_Event_Timer
      If Launch = #True
        Count+1

        StartDrawing(CanvasOutput(#CANV))
          DrawImage(ImageID(Random(6,1)), X, 0, 128, 128)
          X+128
        
        StopDrawing()
        
        If count = NbrDes
          X = 0
          Count = 0
          Launch = #False
        EndIf
        
      EndIf
    
      
    Case #PB_Event_Gadget
      If EventGadget() = #BT_LAUNCH
        RandomSeed( RandomiZ() )
        StartDrawing(CanvasOutput(#canv))
        Box(0,0,LargWin,128,$111111)
        StopDrawing()
        If SoundOn = #True
          PlaySound(#SON)
        EndIf
        
        launch = #True
        
      ElseIf EventGadget() = #BT_CHANGE
        Change()
      EndIf
      
    Case #PB_Event_CloseWindow
      quitte = 1
  EndSelect
Until quitte = 1

End




; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 42
; FirstLine = 39
; Folding = -
; EnableXP
; UseIcon = C:\Users\arswo\Pictures\LDVMpp.ico
; Executable = virtual_dices.exe
; EnableCompileCount = 133
; EnableBuildCount = 2
; IncludeVersionInfo
; VersionField0 = 1.0.0.0
; VersionField1 = 1.0.0.0
; VersionField2 = LDV MULTIMEDIA
; VersionField3 = VIRTUAL DICES
; VersionField4 = 1.0.0.0
; VersionField5 = 1.0.0.0
; VersionField6 = DICES SIMULATOR
; VersionField7 = DICES SIMULATOR
; VersionField8 = DICES SIMULATOR
; VersionField9 = LDV MULTIMEDIA
; VersionField10 = (c) LDV MULTIMEDIA
; VersionField11 = DICES SIMULATOR
; VersionField12 = Freeware
; VersionField13 = info@ldvmultimedia.com
; VersionField14 = http://ldvmultimedia.com